package com.rjconsultores.ventaboletos.dao.hibernate;

import java.util.List;

import org.hibernate.Criteria;
import org.hibernate.SessionFactory;
import org.hibernate.criterion.Order;
import org.hibernate.criterion.Restrictions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Repository;

import com.rjconsultores.ventaboletos.dao.AgruparParadaDAO;
import com.rjconsultores.ventaboletos.entidad.AgrupamentoParada;

@Repository("agruparParadaDAO")
public class AgruparParadaHibernateDAO extends GenericHibernateDAO<AgrupamentoParada, Integer> implements AgruparParadaDAO {

	@Autowired
	public AgruparParadaHibernateDAO(@Qualifier("sessionFactory") SessionFactory factory) {
		setSessionFactory(factory);
	}

	@Override
	public List<AgrupamentoParada> obtenerTodos() {
		Criteria c = getSession().createCriteria(getPersistentClass());
		c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));
		c.addOrder(Order.asc("descAgrupamentoParada"));
		return c.list();
	}

	@Override
	public List<AgrupamentoParada> buscar(String descparada) {
		Criteria c = getSession().createCriteria(getPersistentClass());
		c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));
		c.add(Restrictions.eq("descAgrupamentoParada", descparada));
		return c.list();
	}

	@Override
	public List<AgrupamentoParada> buscarCVE(String cveAgrupamentoParada) {
		Criteria c = getSession().createCriteria(getPersistentClass());
		c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));
		c.add(Restrictions.eq("cveAgrupamentoParada", cveAgrupamentoParada));
		return c.list();
	}

}
